Index: cpukit/libblock/src/bdbuf.c
===================================================================
--- cpukit/libblock/src/bdbuf.c	(revision f14a21df691328cefa1464fc5ef13c0584bbfaf3)
+++ cpukit/libblock/src/bdbuf.c	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -16,5 +16,5 @@
  *         Alexander Kukuta <kam@oktet.ru>
  *
- * Copyright (C) 2008 Chris Johns <chrisj@rtems.org>
+ * Copyright (C) 2008,2009 Chris Johns <chrisj@rtems.org>
  *    Rewritten to remove score mutex access. Fixes many performance
  *    issues.
@@ -45,13 +45,87 @@
 #include "rtems/bdbuf.h"
 
-/**
- * The BD buffer context.
- */
-typedef struct rtems_bdbuf_context {
-  rtems_bdbuf_pool* pool;      /*< Table of buffer pools */
-  int               npools;    /*< Number of entries in pool table */
-  rtems_id          swapout;   /*< Swapout task ID */
-  bool              swapout_enabled;
-} rtems_bdbuf_context;
+/*
+ * Simpler label for this file.
+ */
+#define bdbuf_config rtems_bdbuf_configuration
+
+/**
+ * A swapout transfer transaction data. This data is passed to a worked thread
+ * to handle the write phase of the transfer.
+ */
+typedef struct rtems_bdbuf_swapout_transfer
+{
+  rtems_chain_control   bds;       /**< The transfer list of BDs. */
+  dev_t                 dev;       /**< The device the transfer is for. */
+  rtems_blkdev_request* write_req; /**< The write request array. */
+} rtems_bdbuf_swapout_transfer;
+
+/**
+ * Swapout worker thread. These are available to take processing from the
+ * main swapout thread and handle the I/O operation.
+ */
+typedef struct rtems_bdbuf_swapout_worker
+{
+  rtems_chain_node             link;     /**< The threads sit on a chain when
+                                          * idle. */
+  rtems_id                     id;       /**< The id of the task so we can wake
+                                          * it. */
+  volatile bool                enabled;  /**< The worked is enabled. */
+  rtems_bdbuf_swapout_transfer transfer; /**< The transfer data for this
+                                          * thread. */
+} rtems_bdbuf_swapout_worker;
+
+/**
+ * The BD buffer cache.
+ */
+typedef struct rtems_bdbuf_cache
+{
+  rtems_id            swapout;           /**< Swapout task ID */
+  volatile bool       swapout_enabled;   /**< Swapout is only running if
+                                          * enabled. Set to false to kill the
+                                          * swap out task. It deletes itself. */
+  rtems_chain_control swapout_workers;   /**< The work threads for the swapout
+                                          * task. */
+  
+  rtems_bdbuf_buffer* bds;               /**< Pointer to table of buffer
+                                          * descriptors. */
+  void*               buffers;           /**< The buffer's memory. */
+  size_t              buffer_min_count;  /**< Number of minimum size buffers
+                                          * that fit the buffer memory. */
+  size_t              max_bds_per_group; /**< The number of BDs of minimum
+                                          * buffer size that fit in a group. */
+  uint32_t            flags;             /**< Configuration flags. */
+
+  rtems_id            lock;              /**< The cache lock. It locks all
+                                          * cache data, BD and lists. */
+  rtems_id            sync_lock;         /**< Sync calls block writes. */
+  volatile bool       sync_active;       /**< True if a sync is active. */
+  volatile rtems_id   sync_requester;    /**< The sync requester. */
+  volatile dev_t      sync_device;       /**< The device to sync and -1 not a
+                                          * device sync. */
+
+  rtems_bdbuf_buffer* tree;              /**< Buffer descriptor lookup AVL tree
+                                          * root. There is only one. */
+  rtems_chain_control ready;             /**< Free buffers list, read-ahead, or
+                                          * resized group buffers. */
+  rtems_chain_control lru;               /**< Least recently used list */
+  rtems_chain_control modified;          /**< Modified buffers list */
+  rtems_chain_control sync;              /**< Buffers to sync list */
+
+  rtems_id            access;            /**< Obtain if waiting for a buffer in
+                                          * the ACCESS state. */
+  volatile uint32_t   access_waiters;    /**< Count of access blockers. */
+  rtems_id            transfer;          /**< Obtain if waiting for a buffer in
+                                          * the TRANSFER state. */
+  volatile uint32_t   transfer_waiters;  /**< Count of transfer blockers. */
+  rtems_id            waiting;           /**< Obtain if waiting for a buffer
+                                          * and the none are available. */
+  volatile uint32_t   wait_waiters;      /**< Count of waiting blockers. */
+
+  size_t              group_count;       /**< The number of groups. */
+  rtems_bdbuf_group*  groups;            /**< The groups. */
+  
+  bool                initialised;       /**< Initialised state. */
+} rtems_bdbuf_cache;
 
 /**
@@ -61,16 +135,20 @@
   (((uint32_t)'B' << 24) | ((uint32_t)(n) & (uint32_t)0x00FFFFFF))
 
-#define RTEMS_BLKDEV_FATAL_BDBUF_CONSISTENCY RTEMS_BLKDEV_FATAL_ERROR(1)
-#define RTEMS_BLKDEV_FATAL_BDBUF_SWAPOUT     RTEMS_BLKDEV_FATAL_ERROR(2)
-#define RTEMS_BLKDEV_FATAL_BDBUF_SYNC_LOCK   RTEMS_BLKDEV_FATAL_ERROR(3)
-#define RTEMS_BLKDEV_FATAL_BDBUF_SYNC_UNLOCK RTEMS_BLKDEV_FATAL_ERROR(4)
-#define RTEMS_BLKDEV_FATAL_BDBUF_POOL_LOCK   RTEMS_BLKDEV_FATAL_ERROR(5)
-#define RTEMS_BLKDEV_FATAL_BDBUF_POOL_UNLOCK RTEMS_BLKDEV_FATAL_ERROR(6)
-#define RTEMS_BLKDEV_FATAL_BDBUF_POOL_WAIT   RTEMS_BLKDEV_FATAL_ERROR(7)
-#define RTEMS_BLKDEV_FATAL_BDBUF_POOL_WAKE   RTEMS_BLKDEV_FATAL_ERROR(8)
-#define RTEMS_BLKDEV_FATAL_BDBUF_SO_WAKE     RTEMS_BLKDEV_FATAL_ERROR(9)
-#define RTEMS_BLKDEV_FATAL_BDBUF_SO_NOMEM    RTEMS_BLKDEV_FATAL_ERROR(10)
-#define BLKDEV_FATAL_BDBUF_SWAPOUT_RE        RTEMS_BLKDEV_FATAL_ERROR(11)
-#define BLKDEV_FATAL_BDBUF_SWAPOUT_TS        RTEMS_BLKDEV_FATAL_ERROR(12)
+#define RTEMS_BLKDEV_FATAL_BDBUF_CONSISTENCY  RTEMS_BLKDEV_FATAL_ERROR(1)
+#define RTEMS_BLKDEV_FATAL_BDBUF_SWAPOUT      RTEMS_BLKDEV_FATAL_ERROR(2)
+#define RTEMS_BLKDEV_FATAL_BDBUF_SYNC_LOCK    RTEMS_BLKDEV_FATAL_ERROR(3)
+#define RTEMS_BLKDEV_FATAL_BDBUF_SYNC_UNLOCK  RTEMS_BLKDEV_FATAL_ERROR(4)
+#define RTEMS_BLKDEV_FATAL_BDBUF_CACHE_LOCK   RTEMS_BLKDEV_FATAL_ERROR(5)
+#define RTEMS_BLKDEV_FATAL_BDBUF_CACHE_UNLOCK RTEMS_BLKDEV_FATAL_ERROR(6)
+#define RTEMS_BLKDEV_FATAL_BDBUF_CACHE_WAIT_1 RTEMS_BLKDEV_FATAL_ERROR(7)
+#define RTEMS_BLKDEV_FATAL_BDBUF_CACHE_WAIT_2 RTEMS_BLKDEV_FATAL_ERROR(8)
+#define RTEMS_BLKDEV_FATAL_BDBUF_CACHE_WAIT_3 RTEMS_BLKDEV_FATAL_ERROR(9)
+#define RTEMS_BLKDEV_FATAL_BDBUF_CACHE_WAKE   RTEMS_BLKDEV_FATAL_ERROR(10)
+#define RTEMS_BLKDEV_FATAL_BDBUF_SO_WAKE      RTEMS_BLKDEV_FATAL_ERROR(11)
+#define RTEMS_BLKDEV_FATAL_BDBUF_SO_NOMEM     RTEMS_BLKDEV_FATAL_ERROR(12)
+#define RTEMS_BLKDEV_FATAL_BDBUF_SO_WK_CREATE RTEMS_BLKDEV_FATAL_ERROR(13)
+#define RTEMS_BLKDEV_FATAL_BDBUF_SO_WK_START  RTEMS_BLKDEV_FATAL_ERROR(14)
+#define BLKDEV_FATAL_BDBUF_SWAPOUT_RE         RTEMS_BLKDEV_FATAL_ERROR(15)
+#define BLKDEV_FATAL_BDBUF_SWAPOUT_TS         RTEMS_BLKDEV_FATAL_ERROR(16)
 
 /**
@@ -92,5 +170,5 @@
  * @warning Priority inheritance is on.
  */
-#define RTEMS_BDBUF_POOL_LOCK_ATTRIBS \
+#define RTEMS_BDBUF_CACHE_LOCK_ATTRIBS \
   (RTEMS_PRIORITY | RTEMS_BINARY_SEMAPHORE | \
    RTEMS_INHERIT_PRIORITY | RTEMS_NO_PRIORITY_CEILING | RTEMS_LOCAL)
@@ -104,5 +182,5 @@
  *          IDLE task which can cause unsual side effects.
  */
-#define RTEMS_BDBUF_POOL_WAITER_ATTRIBS \
+#define RTEMS_BDBUF_CACHE_WAITER_ATTRIBS \
   (RTEMS_PRIORITY | RTEMS_SIMPLE_BINARY_SEMAPHORE | \
    RTEMS_NO_INHERIT_PRIORITY | RTEMS_NO_PRIORITY_CEILING | RTEMS_LOCAL)
@@ -114,7 +192,7 @@
 
 /**
- * The context of buffering layer.
- */
-static rtems_bdbuf_context rtems_bdbuf_ctx;
+ * The Buffer Descriptor cache.
+ */
+static rtems_bdbuf_cache bdbuf_cache;
 
 /**
@@ -637,68 +715,68 @@
 
 /**
- * Get the pool for the device.
- *
- * @param pid Physical disk device.
- */
-static rtems_bdbuf_pool*
-rtems_bdbuf_get_pool (const rtems_bdpool_id pid)
-{
-  return &rtems_bdbuf_ctx.pool[pid];
-}
-
-/**
- * Lock the pool. A single task can nest calls.
- *
- * @param pool The pool to lock.
+ * Lock the mutex. A single task can nest calls.
+ *
+ * @param lock The mutex to lock.
+ * @param fatal_error_code The error code if the call fails.
  */
 static void
-rtems_bdbuf_lock_pool (rtems_bdbuf_pool* pool)
-{
-  rtems_status_code sc = rtems_semaphore_obtain (pool->lock,
+rtems_bdbuf_lock (rtems_id lock, uint32_t fatal_error_code)
+{
+  rtems_status_code sc = rtems_semaphore_obtain (lock,
                                                  RTEMS_WAIT,
                                                  RTEMS_NO_TIMEOUT);
   if (sc != RTEMS_SUCCESSFUL)
-    rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_POOL_LOCK);
-}
-
-/**
- * Unlock the pool.
- *
- * @param pool The pool to unlock.
+    rtems_fatal_error_occurred (fatal_error_code);
+}
+
+/**
+ * Unlock the mutex.
+ *
+ * @param lock The mutex to unlock.
+ * @param fatal_error_code The error code if the call fails.
  */
 static void
-rtems_bdbuf_unlock_pool (rtems_bdbuf_pool* pool)
-{
-  rtems_status_code sc = rtems_semaphore_release (pool->lock);
+rtems_bdbuf_unlock (rtems_id lock, uint32_t fatal_error_code)
+{
+  rtems_status_code sc = rtems_semaphore_release (lock);
   if (sc != RTEMS_SUCCESSFUL)
-    rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_POOL_UNLOCK);
-}
-
-/**
- * Lock the pool's sync. A single task can nest calls.
- *
- * @param pool The pool's sync to lock.
+    rtems_fatal_error_occurred (fatal_error_code);
+}
+
+/**
+ * Lock the cache. A single task can nest calls.
  */
 static void
-rtems_bdbuf_lock_sync (rtems_bdbuf_pool* pool)
-{
-  rtems_status_code sc = rtems_semaphore_obtain (pool->sync_lock,
-                                                 RTEMS_WAIT,
-                                                 RTEMS_NO_TIMEOUT);
-  if (sc != RTEMS_SUCCESSFUL)
-    rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_SYNC_LOCK);
-}
-
-/**
- * Unlock the pool's sync.
- *
- * @param pool The pool's sync to unlock.
+rtems_bdbuf_lock_cache (void)
+{
+  rtems_bdbuf_lock (bdbuf_cache.lock, RTEMS_BLKDEV_FATAL_BDBUF_CACHE_LOCK);
+}
+
+/**
+ * Unlock the cache.
  */
 static void
-rtems_bdbuf_unlock_sync (rtems_bdbuf_pool* pool)
-{
-  rtems_status_code sc = rtems_semaphore_release (pool->sync_lock);
-  if (sc != RTEMS_SUCCESSFUL)
-    rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_SYNC_UNLOCK);
+rtems_bdbuf_unlock_cache (void)
+{
+  rtems_bdbuf_unlock (bdbuf_cache.lock, RTEMS_BLKDEV_FATAL_BDBUF_CACHE_UNLOCK);
+}
+
+/**
+ * Lock the cache's sync. A single task can nest calls.
+ */
+static void
+rtems_bdbuf_lock_sync (void)
+{
+  rtems_bdbuf_lock (bdbuf_cache.sync_lock, RTEMS_BLKDEV_FATAL_BDBUF_SYNC_LOCK);
+}
+
+/**
+ * Unlock the cache's sync lock. Any blocked writers are woken.
+ */
+static void
+rtems_bdbuf_unlock_sync (void)
+{
+  rtems_bdbuf_unlock (bdbuf_cache.sync_lock,
+                      RTEMS_BLKDEV_FATAL_BDBUF_SYNC_UNLOCK);
 }
 
@@ -709,20 +787,18 @@
  * tasks that could be waiting.
  *
- * While we have the pool locked we can try and claim the semaphore and
- * therefore know when we release the lock to the pool we will block until the
+ * While we have the cache locked we can try and claim the semaphore and
+ * therefore know when we release the lock to the cache we will block until the
  * semaphore is released. This may even happen before we get to block.
  *
  * A counter is used to save the release call when no one is waiting.
  *
- * The function assumes the pool is locked on entry and it will be locked on
+ * The function assumes the cache is locked on entry and it will be locked on
  * exit.
  *
- * @param pool The pool to wait for a buffer to return.
  * @param sema The semaphore to block on and wait.
  * @param waiters The wait counter for this semaphore.
  */
 static void
-rtems_bdbuf_wait (rtems_bdbuf_pool* pool, rtems_id* sema,
-                  volatile uint32_t* waiters)
+rtems_bdbuf_wait (rtems_id* sema, volatile uint32_t* waiters)
 {
   rtems_status_code sc;
@@ -735,13 +811,11 @@
 
   /*
-   * Disable preemption then unlock the pool and block.
-   * There is no POSIX condition variable in the core API so
-   * this is a work around.
+   * Disable preemption then unlock the cache and block.  There is no POSIX
+   * condition variable in the core API so this is a work around.
    *
-   * The issue is a task could preempt after the pool is unlocked
-   * because it is blocking or just hits that window, and before
-   * this task has blocked on the semaphore. If the preempting task
-   * flushes the queue this task will not see the flush and may
-   * block for ever or until another transaction flushes this
+   * The issue is a task could preempt after the cache is unlocked because it is
+   * blocking or just hits that window, and before this task has blocked on the
+   * semaphore. If the preempting task flushes the queue this task will not see
+   * the flush and may block for ever or until another transaction flushes this
    * semaphore.
    */
@@ -749,22 +823,22 @@
 
   if (sc != RTEMS_SUCCESSFUL)
-    rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_POOL_WAIT);
-  
-  /*
-   * Unlock the pool, wait, and lock the pool when we return.
-   */
-  rtems_bdbuf_unlock_pool (pool);
+    rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_CACHE_WAIT_1);
+  
+  /*
+   * Unlock the cache, wait, and lock the cache when we return.
+   */
+  rtems_bdbuf_unlock_cache ();
 
   sc = rtems_semaphore_obtain (*sema, RTEMS_WAIT, RTEMS_NO_TIMEOUT);
   
   if (sc != RTEMS_UNSATISFIED)
-    rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_POOL_WAIT);
-  
-  rtems_bdbuf_lock_pool (pool);
+    rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_CACHE_WAIT_2);
+  
+  rtems_bdbuf_lock_cache ();
 
   sc = rtems_task_mode (prev_mode, RTEMS_ALL_MODE_MASKS, &prev_mode);
 
   if (sc != RTEMS_SUCCESSFUL)
-    rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_POOL_WAIT);
+    rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_CACHE_WAIT_3);
   
   *waiters -= 1;
@@ -788,5 +862,5 @@
   
     if (sc != RTEMS_SUCCESSFUL)
-      rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_POOL_WAKE);
+      rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_CACHE_WAKE);
   }
 }
@@ -794,8 +868,8 @@
 /**
  * Add a buffer descriptor to the modified list. This modified list is treated
- * a litte differently to the other lists. To access it you must have the pool
+ * a litte differently to the other lists. To access it you must have the cache
  * locked and this is assumed to be the case on entry to this call.
  *
- * If the pool has a device being sync'ed and the bd is for that device the
+ * If the cache has a device being sync'ed and the bd is for that device the
  * call must block and wait until the sync is over before adding the bd to the
  * modified list. Once a sync happens for a device no bd's can be added the
@@ -807,28 +881,26 @@
  * active.
  *
- * @param pool The pool the bd belongs to.
- * @param bd The bd to queue to the pool's modified list.
+ * @param bd The bd to queue to the cache's modified list.
  */
 static void
-rtems_bdbuf_append_modified (rtems_bdbuf_pool* pool, rtems_bdbuf_buffer* bd)
-{
-  /*
-   * If the pool has a device being sync'ed check if this bd is for that
-   * device. If it is unlock the pool and block on the sync lock. once we have
-   * the sync lock reelase it.
-   *
-   * If the 
-   */
-  if (pool->sync_active && (pool->sync_device == bd->dev))
-  {
-    rtems_bdbuf_unlock_pool (pool);
-    rtems_bdbuf_lock_sync (pool);
-    rtems_bdbuf_unlock_sync (pool);
-    rtems_bdbuf_lock_pool (pool);
+rtems_bdbuf_append_modified (rtems_bdbuf_buffer* bd)
+{
+  /*
+   * If the cache has a device being sync'ed check if this bd is for that
+   * device. If it is unlock the cache and block on the sync lock. Once we have
+   * the sync lock release it.
+   */
+  if (bdbuf_cache.sync_active && (bdbuf_cache.sync_device == bd->dev))
+  {
+    rtems_bdbuf_unlock_cache ();
+    /* Wait for the sync lock */
+    rtems_bdbuf_lock_sync ();
+    rtems_bdbuf_unlock_sync ();
+    rtems_bdbuf_lock_cache ();
   }
       
   bd->state = RTEMS_BDBUF_STATE_MODIFIED;
 
-  rtems_chain_append (&pool->modified, &bd->link);
+  rtems_chain_append (&bdbuf_cache.modified, &bd->link);
 }
 
@@ -839,5 +911,5 @@
 rtems_bdbuf_wake_swapper (void)
 {
-  rtems_status_code sc = rtems_event_send (rtems_bdbuf_ctx.swapout,
+  rtems_status_code sc = rtems_event_send (bdbuf_cache.swapout,
                                            RTEMS_BDBUF_SWAPOUT_SYNC);
   if (sc != RTEMS_SUCCESSFUL)
